Type GameData
  Board(5, 14) As Integer
  Top(5) As Integer
  Cur(2) As Integer
  CurX As Integer
  CurY As Integer
  Dropping As Integer
  NextJewel(2) As Integer
  NextOK As Integer
  Action As Integer
  Lv As Integer
  CurLv As Integer
  TimeWait As Integer    ' to delay action e.g. move jewel downward
  Diff As Integer
  Jewels As Integer
  TilesPlayed As Integer
  Score As Integer
  Chains As Integer      ' multiplier of score in chains
  LeftKey As Integer     ' Key States
  LeftKeyWait As Integer ' Time to wait for response
  RightKey As Integer
  RightKeyWait As Integer
  Rotate As Integer      ' Rotate does not affect block continuously
  RotateWait As Integer  ' Used in entering names
  Drop As Integer        ' Drop also
  DropWait As Integer    ' Used in entering names
  LeftKeyBuf As Integer  ' Key Buffer
  RightKeyBuf As Integer ' Wait for response for at least once
  RotateBuf As Integer
  DropBuf As Integer
  Ini As String * 3      ' Name for high scores
  Place As Integer          ' Place for high scores
  PlaceStatus As Integer
End Type

Type HighRecord
  Ini As String * 3
  Score As Long
  Jewels As Long
End Type

Const kTrue = -1, kFalse = Not kTrue
Dim Shared As String*39 NameStr = " ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-."

Dim Shared Game() As GameData
Dim Shared High(3, 1 To 10) As HighRecord